#include <EEPROM.h>
#define buttonFN 2       // подклдючается кнопка FN - PB2
#define buttonOK 1      // подклдючается кнопка OK - PB1
#define redLedPin 4      // подклдючается YELLOW LED - PB4
#define greenLedPin 3      // подклдючается GREEN - PB0
#define powerOutPin 0          // подклдючается затвор ключа - PB0
#define PUSH 0              // нажата более 0,2 секунды
#define PULL 1              // отпущена более 0,2 секунды

int address = 0;                                // адрес хранения текущего состояния в EEPROM 
boolean statePowerPin = LOW;                       // текущее состояние выхода на затвор
boolean stateGreenPin = LOW;                   // текущее состояние выхода на с/диод
boolean stateRedPin = LOW;                // текущее состояние выхода на с/диод
boolean buttonFNFlag = PULL;                 // текущее состояние 1 кнопки управления
boolean buttonOKFlag = PULL;                // текущее состояние 2 кнопки управления
unsigned int counterButtonFirst = 0;
unsigned int counterButtonSecond = 0;
unsigned int stateProg = 0;
unsigned int counterProg = 0;

void setup() 
{
  pinMode(buttonFN, INPUT_PULLUP);              // пин кнопки, вход к плюсу подтяну на плате через резистор
  pinMode(buttonOK, INPUT_PULLUP);             // пин кнопки, вход к плюсу подтяну на плате через резистор
  pinMode(powerOutPin, OUTPUT);                          // пин управления, выход
  pinMode(redLedPin, OUTPUT);                         // пин с подключенным RED светодиодом
  pinMode(greenLedPin, OUTPUT);                       // пин с подключенным GREEN светодиодом
  digitalWrite(redLedPin, HIGH);              // turn the LED on (HIGH is the voltage level)
  digitalWrite(greenLedPin, HIGH);              // turn the LED on (HIGH is the voltage level)
  delay (10);
  digitalWrite(redLedPin, LOW);              // turn the LED on (HIGH is the voltage level)
  statePowerPin = EEPROM.read(address); 
  digitalWrite(powerOutPin, statePowerPin);              // turn the LED on (HIGH is the voltage level)
  stateGreenPin = statePowerPin;
  digitalWrite(greenLedPin, stateGreenPin);              // turn the LED on (HIGH is the voltage level)
}

//********************************************************
// проверяем текущее состояние кнопок если изменение дольше 0,1 секунды, значит состояние меняется
//********************************************************

void buttonState() 
{
int tempState = digitalRead(buttonFN);
if (buttonFNFlag != tempState)           // кнопка изменила состояние
  {
  counterButtonFirst++;
  if (counterButtonFirst >= 100)
    {
      counterButtonFirst = 0;
      buttonFNFlag = tempState;
    }
  }

// кнопка не изменила состояние
tempState = digitalRead(buttonOK);
if (buttonOKFlag != tempState) // кнопка изменила состояние
  {
  counterButtonSecond++;
  if (counterButtonSecond >= 100)
    {
      counterButtonSecond = 0;
      buttonOKFlag = tempState;
    }
  }
}


//***************************************************
// оснойной цикл программы
//***************************************************

void loop() 
{
buttonState();

if ((buttonFNFlag == PULL && buttonOKFlag == PULL) || (buttonFNFlag == PULL && buttonOKFlag == PUSH)) 
{
  stateProg = 99;
  counterProg = 0;
  stateRedPin = LOW;
  digitalWrite(redLedPin, stateRedPin);
}
  
  switch (stateProg)
    {
//****************************************************************************
// 
//  ждем нажатия и удержания первой кнопки
//
//****************************************************************************
    case 99:
      if (buttonFNFlag == PULL && buttonOKFlag == PULL)
      {
        stateRedPin = LOW;
        digitalWrite(redLedPin, stateRedPin);
        stateProg = 0;
      }
    break;
//****************************************************************************
// 
//  ждем нажатия и удержания первой кнопки
//
//****************************************************************************
    case 0:
    if (buttonFNFlag == PUSH && buttonOKFlag == PULL)
      {
        counterProg ++;
        if (counterProg > 5000) 
        {
          stateRedPin = HIGH;
          digitalWrite(redLedPin, stateRedPin);
          counterProg = 0;
          stateProg = 1;
        }
      }
    break;
//****************************************************************************
// 
//  при нажатой первой кнопке, ждем нажатия и удержания второй кнопки
//
//****************************************************************************
    case 1:
    {
    if (counterProg++ > 10000) 
    {
      stateRedPin = LOW;
      digitalWrite(redLedPin, stateRedPin);
      counterProg = 0;
      stateProg = 99;
      break;
    }
    if (buttonFNFlag == PUSH && buttonOKFlag == PUSH)
    {
      counterProg ++;
      if (counterProg > 5000) 
      {
        stateGreenPin = !stateGreenPin;
        statePowerPin = stateGreenPin;
        digitalWrite(greenLedPin, stateGreenPin);
        digitalWrite(powerOutPin, statePowerPin);
        EEPROM.write(address,statePowerPin ); 

        
        counterProg = 0;
        stateProg = 99;    
      }
    }
      break;
    }
  }   
}

//  EEPROM.write(address, value);
